//Buggy control with Clicker2 for STM32

#include "Blep.h"

sbit BREAK_LAMPS at LATD6_bit;
sbit HEAD_LAMPS  at LATF0_bit;
sbit TURN_L      at LATB8_bit;
sbit TURN_R      at LATD7_bit;
sbit MAIN_BEAM   at LATA6_bit;

//BUGGY COMMANDS
#define CMD_DRIVE                0x01
#define CMD_BREAK                0x02
#define CMD_RESPOND              0x03
#define CMD_SPIN                 0x04

unsigned int SPEED_L;
unsigned int SPEED_R;

unsigned int PWM_A_PERIOD  = 255;
unsigned int PWM_B_PERIOD  = 255;
unsigned int PWM_C_PERIOD  = 255;
unsigned int PWM_D_PERIOD  = 255;

extern char writeBuff[32];
extern short readBuff[32];

char old_cmd = CMD_BREAK;
char txPipe;

void Init_Buggy() {
//GPIO
  TRISD6_bit = 0;
  TRISF0_bit = 0;
  TRISB8_bit = 0;
  TRISD7_bit = 0;
  TRISA6_bit = 0;

//BAT VSENSE
  TRISB11_bit = 1;
  Adc1_Init();
  
//PWM
  SPEED_L = 0;
  SPEED_R = 0;
  PWM_A_PERIOD = PWM_Init(20000, 3, 0, 2);
  PWM_B_PERIOD = PWM_Init(20000, 2, 0, 2);
  PWM_C_PERIOD = PWM_Init(20000, 4, 0, 2);
  PWM_D_PERIOD = PWM_Init(20000, 1, 0, 2);

  PWM_Start(3);                       // start PWM3
  PWM_Start(2);                       // start PWM2
  PWM_Start(4);                       // start PWM4
  PWM_Start(1);                       // start PWM2
  PWM_Set_Duty(0,3);
  PWM_Set_Duty(0,2);
  PWM_Set_Duty(0,4);
  PWM_Set_Duty(0,1);


}

void HeadLamps_Blink() {
  HEAD_LAMPS = 1;
  delay_ms(200);
  HEAD_LAMPS = 0;
  delay_ms(500);
  HEAD_LAMPS = 1;
  delay_ms(200);
  HEAD_LAMPS = 0;
}

void TurnLamps_Blink() {
  char n;
  
  for(n=0; n<7; n++) {
    TURN_L = ~ TURN_L;
    TURN_R = ~ TURN_R;
    delay_ms(200);
  }
  TURN_L = 0;
  TURN_R = 0;
}

void Lights_Off() {

}

void Break_Buggy() {
  SPEED_L = 0;
  SPEED_R = 0;
  PWM_Start(3);                       // start PWM3
  PWM_Start(2);                       // start PWM2
  PWM_Start(4);                       // start PWM4
  PWM_Start(1);                       // start PWM1
  PWM_Set_Duty(0,3);
  PWM_Set_Duty(0,2);
  PWM_Set_Duty(0,4);
  PWM_Set_Duty(0,1);
}


static void Test_Drive() {
  Break_Buggy();
  PWM_Set_Duty(PWM_A_PERIOD >> 1, 3);  //PWM_A  left_forward
  PWM_Set_Duty(PWM_D_PERIOD >> 1, 1);  //PWM_D  right_forward
  delay_ms(5000);
  Break_Buggy();
  PWM_Set_Duty(PWM_B_PERIOD >> 1, 2);  //PWM_B  left_reverse
  PWM_Set_Duty(PWM_C_PERIOD >> 1, 4);  //PWM_C  right_reverse
  delay_ms(5000);
  Break_Buggy();
}

static void Full_Circle_Left() {
  double dbl_temp = (double)readBuff[6] / 100;
  unsigned int spin_speed;
  Break_Buggy();
  spin_speed = (unsigned int) (PWM_D_PERIOD * dbl_temp);
  PWM_Set_Duty(spin_speed, 1);  //PWM_D  right_forward
  spin_speed = (unsigned int) (PWM_B_PERIOD * dbl_temp);
  PWM_Set_Duty(spin_speed, 2);  //PWM_B  left_reverse
  TURN_L = ~TURN_L;
  TURN_R = ~TURN_R;
}

static void Full_Circle_Right() {
  double dbl_temp = (double)readBuff[6] / 100;
  unsigned int spin_speed;
  Break_Buggy();
  spin_speed = (unsigned int) (PWM_A_PERIOD * dbl_temp);
  PWM_Set_Duty(spin_speed, 3);  //PWM_A  left_forward
  spin_speed = (unsigned int) (PWM_C_PERIOD * dbl_temp);
  PWM_Set_Duty(spin_speed, 4);  //PWM_C  right_reverse
  TURN_L = ~TURN_L;
  TURN_R = ~TURN_R;
}


void Start_Buggy() {
  PWM_Start(3);                       // start PWM1
  PWM_Start(2);                       // start PWM2
  PWM_Start(4);                       // start PWM3
  PWM_Start(1);                       // start PWM5

  //HeadLamps_Blink();
  TurnLamps_Blink();
  //Test_Drive();
  //Full_Circle_Left();
  //delay_ms(2000);
  Break_Buggy();
}

void Drive_Buggy() {
   double dbl_temp;
   char dir = readBuff[5];
   char vel_left = readBuff[6];
   char vel_right = readBuff[7];

   if (dir != 0) { //reverse direction
       //left motors
       dbl_temp = (double)vel_left / 100;                                        //Convert received speed in %
       SPEED_L = (unsigned int) (PWM_B_PERIOD * dbl_temp);
       PWM_Set_Duty(0, 3);                 // left forward PWM
       PWM_Set_Duty(SPEED_L, 2);           // left reverse PWM
       //right motors
       dbl_temp = (double)vel_right / 100;
       SPEED_R = (unsigned int) (PWM_C_PERIOD * dbl_temp);
       PWM_Set_Duty(0, 1);                 // right forward PWM
       PWM_Set_Duty(SPEED_R, 4);           // right_reverse PWM
   }else{ //forward direction
       //left motors
       dbl_temp = (double)vel_left / 100;                                        //Convert received speed in %
       SPEED_L = (unsigned int) (PWM_A_PERIOD * dbl_temp);
       PWM_Set_Duty(0, 2);                 // left reverse  PWM
       PWM_Set_Duty(SPEED_L, 3);           // left forward  PWM
       //right motors
       dbl_temp = (double)vel_right / 100;
       SPEED_R = (unsigned int) (PWM_D_PERIOD * dbl_temp);
       PWM_Set_Duty(0, 4);                 // right reverse PWM
       PWM_Set_Duty(SPEED_R, 1);           // right forward PWM
   }
}

static void SetBattValueToBuffer(unsigned int Value){
  //Divide to 4x4bit value
  writeBuff[0] = (char)((Value >> 12)& 0xF); //HHHsb
  writeBuff[1] = (char)((Value >> 8)& 0xF);  //HHsb
  writeBuff[2] = (char)((Value >> 4) & 0xF); //Hsb
  writeBuff[3] = (char)(Value & 0xF);        //Lsb
}

//Message format:
//readBuff[0] - Message Lenght
//readBuff[1] - Event
//readBuff[2] - Service Pipe No.
//readBuff[3...20] - Received data
int temp_int;
void OnDataReceived() {
  char next_cmd = readBuff[4];
  switch (next_cmd) {
    case CMD_DRIVE:
      Drive_Buggy();
      break;
    case CMD_BREAK:
      Break_Buggy();
      break;
    case CMD_SPIN:
      if (old_cmd != CMD_SPIN) {
          TURN_L = 0;
          TURN_R = 0;
      }
      
      if (readBuff[5] != 0) {
         Full_Circle_Left();
      }else{
         Full_Circle_Right();
      }
      break;
    case CMD_RESPOND:
      asm nop;
      break;
    default: 
      Break_Buggy();
  }
  
  //lights control

  BREAK_LAMPS = readBuff[8] & 0x01;
  MAIN_BEAM = readBuff[8] >> 3;
  HEAD_LAMPS = readBuff[8] >> 4;
  if (next_cmd != CMD_SPIN) {
    if (readBuff[8] & 0x02) {
      TURN_L = ~TURN_L;
    }else{
      TURN_L = 0;
    }
  
    if (readBuff[8] & 0x04) {
      TURN_R = ~TURN_R;
    }else{
      TURN_R = 0;
    }
  
  }

  //turn off turn lights after spining
  if (next_cmd != old_cmd) {
    if (old_cmd == CMD_SPIN) {
      TURN_L = 0;
      TURN_R = 0;
    }
  }

  old_cmd = next_cmd;
  txPipe = readBuff[2] + 1;
  temp_int = ADC1_Get_Sample(11);
  SetBattValueToBuffer(temp_int);
  Blep_SendData(&writeBuff,6,TxPipe);
  
}